<?php
if (!defined('BB_ROOT')) die(basename(__FILE__));

class PrivateMS
{
	public function add_pm($data, $message = true, $user = true)
	{
		global $userdata, $lang;
		if(IS_GUEST) return;
		
		$sync_forums = array();
		
		$query['sub']		= @$data['sub'];
		$query['uid']		= @$data['uid'];
		$query['time']		= TIMENOW;
		$query['major']		= '1';
		$query['minor']		= @count($data['users']) + 1;
		$query['pm_lock']	= @$data['pm_lock'];
		$query['lp_user']	= @$data['uid'];
		$query['lastime']	= TIMENOW;

		$sql_insert = DB()->build_array('INSERT', $query);
		$sqls = "INSERT INTO ".BB_PM." $sql_insert";
		
		if (!DB()->sql_query($sqls))
		{
			message_die(GENERAL_ERROR, 'Error in added pm', '', __LINE__, __FILE__, $query);
		}
		
		$id = DB()->sql_nextid();

		self::add_pm_text(array('pm_id' => $id, 'us_id' => $query['uid'], 'time' => $query['lastime'], 'text' => @$data['text']));
		self::add_pm_user(array('pid' => $id, 'puid' => $query['uid'], 'type' => PRIVMSGS_READ_MAIL), false);
		
		if(!empty($data['users']))
		{
			if($user)
			{
				foreach(@$data['users'] as $i => $row)
				{
					self::add_pm_user(array('pid' => $id, 'puid' => $row, 'type' => PRIVMSGS_NEW_MAIL));
					self::notify_pm(array('pm_id' => $id, 'user_id' => $row));	
				}	
			}else{
				self::add_pm_user(array('pid' => $id, 'puid' => $data['users'], 'type' => PRIVMSGS_NEW_MAIL));
				self::notify_pm(array('pm_id' => $id, 'user_id' => $data['users']));	
			}
		}else{
			bb_die('ERROR');
		}
		if($message)
		{
			$refresh = meta_refresh(PRIVMS_MODE_URL . PRIVMS_VIEW . "&" . PRIVMS_IDS . $id);
			
			$info_redirect = $lang['STORED'] . '<br /><br />' . sprintf($lang['CLICK_RETURN_TO_PM'], '<a href="'. PRIVMS_MODE_URL . PRIVMS_VIEW . "&" . PRIVMS_IDS . $id .'">', '</a>');
			message_die(GENERAL_MESSAGE, $info_redirect);
		}
	}
	static function add_pm_text($data)
	{		
		$query['pm_id']	= @$data['pm_id'];
		$query['us_id']	= @$data['us_id'];
		$query['text']	= @$data['text'];
		$query['time']	= @$data['time'];

		$sql_insert = DB()->build_array('INSERT', $query);
		$sql = "INSERT INTO ".BB_PM_TEXT." $sql_insert";
		if (!DB()->sql_query($sql))
		{
			message_die(GENERAL_ERROR, 'Could not insert pm text', '', __LINE__, __FILE__, $sql);
		}
		$next_id = DB()->sql_nextid();
		$update = "UPDATE ".BB_PM." SET firstpost = $next_id, lastpost = $next_id WHERE id = ".$query['pm_id']." LIMIT 1";
		
		if (!DB()->sql_query($update))
		{
			message_die(GENERAL_ERROR, 'Error in update pm', '', __LINE__, __FILE__, $update);
		}
	}
	
	public function add_pm_user($data, $update = true)
	{
		$query['pid']		= @$data['pid'];
		$query['puid']		= @$data['puid'];
		$query['pm_type']	= @$data['type'];

		$sql_insert = DB()->build_array('INSERT', $query);
		$sql = "INSERT INTO ".BB_PM_USERS." $sql_insert";
		if (!DB()->sql_query($sql))
		{
			message_die(GENERAL_ERROR, 'Could not insert pm user', '', __LINE__, __FILE__, $sql);
		}
		if($update)
		{
			$sqlUpdate = "UPDATE ". BB_USERS ." SET
					user_new_privmsg = user_new_privmsg + 1,
					user_last_privmsg = ".TIMENOW.",
					user_newest_pm_id = {$query['pid']}
				WHERE user_id = {$query['puid']}
				LIMIT 1";
			if (!DB()->sql_query($sqlUpdate))
			{
				message_die(GENERAL_ERROR, 'Could not update private message new/read status (2) for user', '', __LINE__, __FILE__, $sql);
			}	
			cache_rm_user_sessions ($query['puid']);
		}
		$count = DB()->fetch_row("SELECT COUNT(puid) as count_num
			FROM ".BB_PM_USERS." WHERE pid = {$query['pid']}");
		
		DB()->sql_query("UPDATE ".BB_PM." SET minor = {$count['count_num']} WHERE id = ". $query['pid']);
	}
	
	public function del_pm_user($data)
	{
		$query['pid']		= @$data['pid'];
		$query['puid']		= @$data['puid'];

		$sql = "DELETE FROM ".BB_PM_USERS." WHERE pid = " . $query['pid']." AND puid = ". $query['puid'];
		if (!DB()->sql_query($sql))
		{
			message_die(GENERAL_ERROR, 'Could not delete pm user', '', __LINE__, __FILE__, $sql);
		}
		$count = DB()->fetch_row("SELECT COUNT(puid) as count_num
			FROM ".BB_PM_USERS." WHERE pid = {$query['pid']}");
		
		DB()->sql_query("UPDATE ".BB_PM." SET minor = {$count['count_num']} WHERE id = ". $query['pid']);
	}
	
	static function update_pm_user($data)
	{
		$opt['id'] = @$data['id'];
		$opt['not_user'] = @$data['not_user_id'];
		$opt['type'] = @$data['type'];
		
		$check = DB()->fetch_rowset("SELECT puid FROM ".BB_PM_USERS." WHERE pid = ".$opt['id']);
		
		foreach($check AS $checkS)
		{
			$user_id[] = $checkS['puid'];
		}
		
		$key = array_search($opt['not_user'], $user_id);
		
		if ($key !== false)
		{
			unset($user_id[$key]);
		}else{
			bb_die('ERROR');
		}
		
		$sqlUpdate = "UPDATE ". BB_PM_USERS ."
			SET pm_type = {$opt['type']}
			WHERE pid = {$opt['id']}
			AND puid IN (". implode(',',$user_id) .")";	
			
		if (!DB()->sql_query($sqlUpdate))
		{
			message_die(GENERAL_ERROR, 'Could not update private message user status', '', __LINE__, __FILE__, $sqlUpdate);
		}	
		
		$sqlUpdateA = "UPDATE ". BB_USERS ." SET
				user_new_privmsg = user_new_privmsg + 1,
				user_last_privmsg = ".TIMENOW."				
			WHERE user_id IN (". implode(',',$user_id) .")";	
		if (!DB()->sql_query($sqlUpdateA))
		{
			message_die(GENERAL_ERROR, 'Could not update user status', '', __LINE__, __FILE__, $sqlUpdateA);
		}	
		cache_rm_user_sessions (array(implode(',',$user_id)));
	}
	
	public function add_pm_reply($data, $message = true)
	{
		global $userdata, $lang, $is_auth;
		
		$sync_topics = array();
		
		$sql_pm['pm_id']	= @$data['id'];
		$sql_pm['us_id']	= @$data['us_id'];
		$sql_pm['text']		= @$data['text'];
		$sql_pm['time']		= TIMENOW;
		
		$sql_insert_pm = DB()->build_array('INSERT', $sql_pm);
		$sql = "INSERT INTO ".BB_PM_TEXT." $sql_insert_pm";
				
		if (!DB()->sql_query($sql))
		{
			message_die(GENERAL_ERROR, 'Could not insert repley for pm', '', __LINE__, __FILE__, $sql);
		}
		
		$next_id = DB()->sql_nextid();
		
		$count = DB()->fetch_row("
			SELECT COUNT(tx.tx_id) as count_num
			FROM ".BB_PM." p
				LEFT JOIN ".BB_PM_TEXT." tx  ON(tx.pm_id = p.id)
			WHERE p.id= {$sql_pm['pm_id']}
			LIMIT 1
		");
		
		DB()->sql_query("UPDATE ".BB_PM." SET major = {$count['count_num']}, lastpost = ".$next_id.", lp_user = ".$sql_pm['us_id'].", lastime = ". $sql_pm['time'] ." WHERE id = ". $sql_pm['pm_id']);
		self::update_pm_user(array('id' => $sql_pm['pm_id'], 'not_user_id' => $sql_pm['us_id'], 'type' => PRIVMSGS_NEW_MAIL));
		if($message)
		{
			$refresh = meta_refresh(PRIVMS_MODE_URL . PRIVMS_VIEW . "&" . PRIVMS_IDS . $data['id'] . "&" . PRIVMS_POSTS_URLS . $next_id .'#pm-' . $next_id);
			
			$info_redirect = $lang['STORED'] . '<br /><br />' . sprintf($lang['CLICK_VIEW_MESSAGE'], '<a href="'. PRIVMS_MODE_URL . PRIVMS_VIEW . "&" . PRIVMS_IDS . $data['id'] . "&" . PRIVMS_POSTS_URLS . $next_id .'#pm-'.$next_id.'">', '</a>') . '<br /><br />' . sprintf($lang['CLICK_RETURN_TO_BACK'], '<a href="'. PRIVMS_MODE_URL . PRIVMS_VIEW . "&" . PRIVMS_IDS . $data['id'] .'">', '</a>');
			message_die(GENERAL_MESSAGE, $info_redirect);
		}
		return $data;
	}
	
	public function update_pm_reply($data)
	{
		global $lang;
		
		$id 		= $data['id'];
		$tx_id		= $data['tx_id'];
		$text 		= $data['text'];
		$separator	= $data['separator'];
		
		$sql = "SELECT text FROM " . BB_PM_TEXT . " WHERE tx_id = $tx_id";
		if (!($result = DB()->sql_query($sql)))
		{
			message_die(GENERAL_ERROR, 'Could not obtain pm information', '', __LINE__, __FILE__, $sql);
		}
		$message_row = DB()->sql_fetchrow($result);

		$message = $message_row['text'];
		$message = preg_replace('/\:[0-9a-z\:]+\]/si', ']', $message);
		$message = undo_htmlspecialchars(addslashes($message));
		
		if(!empty($message))
		{
			$UNewMess = $message . $separator . $text;
			$upd = "UPDATE ".BB_PM_TEXT." SET text = '". DB()->escape($UNewMess) ."' WHERE tx_id = $tx_id LIMIT 1";
			if(DB()->query($upd))
			{
				$del = "DELETE FROM ". BB_PM_TEXTHTML ." WHERE tx_id = $tx_id LIMIT 1";
				if(DB()->query($del))
				{
					$refresh = meta_refresh(PRIVMS_MODE_URL . PRIVMS_VIEW . "&" . PRIVMS_IDS . $id . "&" . PRIVMS_POSTS_URLS . $tx_id .'#pm-' . $tx_id);
					
					$info_redirect = $lang['STORED'] . '<br /><br />' . sprintf($lang['CLICK_VIEW_MESSAGE'], '<a href="'. PRIVMS_MODE_URL . PRIVMS_VIEW . "&" . PRIVMS_IDS . $id . "&" . PRIVMS_POSTS_URLS . $tx_id .'#pm-'.$tx_id.'">', '</a>') . '<br /><br />' . sprintf($lang['CLICK_RETURN_TO_BACK'], '<a href="'. PRIVMS_MODE_URL . PRIVMS_VIEW . "&" . PRIVMS_IDS . $id .'">', '</a>');
					message_die(GENERAL_MESSAGE, $info_redirect);
				}else{
					message_die(GENERAL_ERROR, 'error delete old cache for message', '', __LINE__, __FILE__, $del);
				}
			}else{
				message_die(GENERAL_ERROR, 'error update message', '', __LINE__, __FILE__, $upd);
			}
		}else{
			bb_die('error message');
		}
	}
	
	static function notify_pm($data)
	{
		global $bb_cfg, $lang, $bf;
		
		$opt['pm_id']		= @$data['pm_id'];
		$opt['user_id']		= @$data['puid'];
		
		$to_userdata = get_userdata ($opt['user_id']);
		if ( bf($to_userdata['user_opt'], 'user_opt', 'notify_pm') && !empty($to_userdata['user_email']) && $to_userdata['user_active'] && $bb_cfg['pm_notify_enabled'] )
		{
			$script_name = preg_replace('/^\/?(.*?)\/?$/', "\\1", trim($bb_cfg['script_path']));
			$script_name = ( $script_name != '' ) ? $script_name . '/' : '';
			$server_name = trim($bb_cfg['server_name']);
			$server_protocol = ( $bb_cfg['cookie_secure'] ) ? 'https://' : 'http://';
			$server_port = ( $bb_cfg['server_port'] <> 80 ) ? ':' . trim($bb_cfg['server_port']) . '/' : '/';

			include(INC_DIR .'emailer.class.php');
			$emailer = new emailer($bb_cfg['smtp_delivery']);

			$emailer->from($bb_cfg['board_email']);
			$emailer->replyto($bb_cfg['board_email']);

			$emailer->use_template('privmsg_notify', $to_userdata['user_lang']);
			$emailer->email_address($to_userdata['user_email']);
			$emailer->set_subject($lang['NOTIFICATION_SUBJECT']);

			$emailer->assign_vars(array(
				'USERNAME' => stripslashes($to_username),
				'NAME_FROM' => $userdata['username'],
				'MSG_SUBJECT' => stripslashes($privmsg_subject),
				'SITENAME' => $bb_cfg['sitename'],
				'EMAIL_SIG' => (!empty($bb_cfg['board_email_sig'])) ? str_replace('<br />', "\n", "-- \n" . $bb_cfg['board_email_sig']) : '',

				'U_INBOX' => $server_protocol . $server_name . $server_port . $script_name . PRIVMS_MODE_URL . PRIVMS_VIEW . "&" . PRIVMS_IDS . $opt['pm_id'],
			));

			$emailer->send();
			$emailer->reset();
		}
	}

	public function delete_pm ($id, $message = true)
	{
		global $lang;

		
		$sql = "
			SELECT id
			FROM ".BB_PM."
			WHERE id = $id
			LIMIT 1
		";
		
		if (!DB()->sql_query($sql))
		{
			message_die(GENERAL_ERROR, 'Could not search id for pm', '', __LINE__, __FILE__, $sql);
		}
		
		// Get pm to delete
		$tmp_delete_pm = 'tmp_delete_pm';

		DB()->query("
			CREATE TEMPORARY TABLE $tmp_delete_pm (
				id MEDIUMINT UNSIGNED NOT NULL DEFAULT '0',
				PRIMARY KEY (id)
			) ENGINE = MEMORY
		");

		DB()->query("
			INSERT INTO $tmp_delete_pm
				SELECT id
				FROM ".BB_PM."
				WHERE id = $id
				LIMIT 1
		");

		// Get pm count
		$row = DB()->fetch_row("SELECT COUNT(*) AS pm_count FROM $tmp_delete_pm");

		if (!$deleted_pm_count = $row['pm_count'])
		{
			DB()->query("DROP TEMPORARY TABLE $tmp_delete_pm");
			return 0;
		}

		// Delete pm_text_html, pm_text, pm_users
		DB()->query("
			DELETE p, pt, pth, pu
			FROM      ". $tmp_delete_pm  ." del
			LEFT JOIN ".BB_PM." p  ON(p.id = del.id)
			LEFT JOIN ".BB_PM_TEXT." pt ON(pt.pm_id = p.id)
			LEFT JOIN ".BB_PM_TEXTHTML." pth ON(pth.tx_id = pt.tx_id)
			LEFT JOIN ".BB_PM_USERS." pu ON(pu.pid = p.id)
		");

		// Delete topics, topics watch
		DB()->query("
			DELETE p
			FROM      ". $tmp_delete_pm ." del
			LEFT JOIN ".BB_PM." p  USING(id)
		");

		DB()->query("DROP TEMPORARY TABLE $tmp_delete_pm");
		
		if($message)
		{
			$refresh = meta_refresh(PRIVMS);
			
			$info_redirect = $lang['PM_DELETED'] . '<br /><br />' . sprintf($lang['CLICK_RETURN_TO_BACK'], '<a href="'. PRIVMS .'">', '</a>');
			message_die(GENERAL_MESSAGE, $info_redirect);
		}

		return $deleted_pm_count;
	}


	public function delete_reply ($id, $message = true)
	{
		global $lang;

		$sql = "SELECT pt.tx_id, pt.pm_id
				FROM  ".BB_PM." p, ".BB_PM_TEXT." pt
				WHERE pt.tx_id = $id
					AND p.id = pt.pm_id
				LIMIT 1
		";
		
		if (!DB()->sql_query($sql))
		{
			message_die(GENERAL_ERROR, 'Could not search id for pm', '', __LINE__, __FILE__, $sql);
			return false;
		}
		$query = DB()->fetch_row($sql);
		
		$sql_dt = "DELETE FROM ".BB_PM_TEXT." WHERE tx_id = " . $query['tx_id'];
		
		if (!DB()->sql_query($sql_dt))
		{
			message_die(GENERAL_ERROR, 'Could not delete pm for "BB_PM_TEXT" table', '', __LINE__, __FILE__, $sql_dt);
			return false;
		}
		
		$sql_dth = "DELETE FROM ".BB_PM_TEXTHTML." WHERE tx_id = " . $query['tx_id'];
		
		if (!DB()->sql_query($sql_dth))
		{
			message_die(GENERAL_ERROR, 'Could not delete pm for "BB_PM_TEXTHTML" table', '', __LINE__, __FILE__, $sql_dth);
			return false;
		}
		
		$count = DB()->fetch_row("
			SELECT COUNT(tx.tx_id) as count_num
			FROM ".BB_PM." p
				LEFT JOIN ".BB_PM_TEXT." tx  ON(tx.pm_id = p.id)
			WHERE p.id= {$query['pm_id']}
			LIMIT 1
		");
		$check = DB()->fetch_row("
			SELECT tx.us_id, tx.time, tx.pm_id
			FROM ".BB_PM." p
				LEFT JOIN ".BB_PM_TEXT." tx  ON(tx.pm_id = p.id)
			WHERE p.id= {$query['pm_id']}
			GROUP BY tx.time DESC LIMIT 1
		");
		
		DB()->sql_query("UPDATE ".BB_PM." SET major = {$count['count_num']}, lastpost = {$check['pm_id']}, lp_user = {$check['us_id']}, lastime = {$check['time']} WHERE id = ". $query['pm_id']);

		if($message)
		{
			$refresh = meta_refresh(PRIVMS_MODE_URL . PRIVMS_VIEW . "&" . PRIVMS_IDS . $query['pm_id']);
			
			$info_redirect = $lang['DELETED'] . '<br /><br />' . sprintf($lang['CLICK_RETURN_TO_BACK'], '<a href="'. PRIVMS_MODE_URL . PRIVMS_VIEW . "&" . PRIVMS_IDS . $query['pm_id'] .'">', '</a>');
			message_die(GENERAL_MESSAGE, $info_redirect);
		}

		return true;
	}

	public function get_parsed_pm ($data)
	{

		if (!empty($data['pm_html']))
		{
			return $data['pm_html'];
		}

		$message = bbcode2html($data['text']);

		DB()->shutdown['pmhtml'][] = array(
			'tx_id'   => (int) $data['tx_id'],
			'us_id'   => (int) $data['us_id'],
			'pm_html' => (string) $message,
		);

		return $message;
	}
	
}

